<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Document</title>
        <template>
            <style>
                :host {
                    display: block;
                    font-family: sans-serif;
                    text-align: center;
                }

                button {
                    border: none;
                    cursor: pointer;
                }

                ul {
                    list-style: none;
                    padding: 0;
                }
            </style>
            <h1>To do</h1>

            <input type="text" placeholder="Add a new to do" />
            <button>✅</button>

            <ul id="todos"></ul>
        </template>
        <script>
            const template = document.createElement("template");

            class TodoApp extends HTMLElement {
                constructor() {
                    super();
                    this._shadowRoot = this.attachShadow({ mode: "open" });
                    this._shadowRoot.appendChild(template.content.cloneNode(true));
                    this.$todoList = this._shadowRoot.querySelector("ul");
                }
            }

            window.customElements.define("to-do-app", TodoApp);
        </script>
    </head>
</html>
